import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
public class InsertWithRet extends javax.servlet.http.HttpServlet {
    public void doGet(HttpServletRequest request,
		      HttpServletResponse response)
	throws IOException, ServletException {
	response.setContentType("text/html");
	PrintWriter out=response.getWriter();
	out.println("<html><head><title> Test di MySQL </title></head><body>");
	out.println("<H1> Questa pagina è prodotta da <br>"+
		    "una servlet che esegue una query al DB</H1><br>");
	out.println("<table border=\"1\" cellpadding=\"5\""
		    + " cellspacing=\"0\" width=\"400\">");
	String connectionURL="jdbc:postgresql://localhost:5432/esempio";
	    Connection connection = null;
	    Statement statement=null;
	    ResultSet resultSet=null;
	    try {
	    	//caricamento dinamico della classe e
	    	//registrazione del driver presso il driver manager
	    	Class.forName( "org.postgresql.Driver");
	    	// connect to database
	    	connection = DriverManager.getConnection(connectionURL, "esempio_user", "esempio_user_password");
	    	// create Statement to query database
	    	statement = connection.createStatement();
	    	// query database
		if (request.getParameter("libro") != null) {
		    String query_autori_libri;
		    query_autori_libri="INSERT INTO libro(Titolo) VALUES ('";
		    query_autori_libri+=request.getParameter("titolo");
		    query_autori_libri+="') returning libroid, url; ";
		    resultSet =
			statement.executeQuery(query_autori_libri);
		    // process query results
		    StringBuffer results = new StringBuffer();
		    ResultSetMetaData metaData = resultSet.getMetaData();
		    results.append("<tr>");
		    for ( int i = 1; i <= metaData.getColumnCount(); i++ ) {
			results.append( "<td><b>" + metaData.getColumnName( i )
					+ "</b></td>" );
		    }
		    results.append( "</tr>" );
		    while ( resultSet.next() ) {
			results.append("<tr>");
			for ( int i = 1; i <= metaData.getColumnCount(); i++ ) {
			    results.append("<td>"+ resultSet.getObject( i )
					   + "</td>" );
			}
			results.append( "</tr>" );
		    }
		    out.println(results.toString());
		}
		else if (request.getParameter("libronotret") != null) {
		    String query_autori_libri;
		    query_autori_libri="INSERT INTO libro(Titolo) VALUES ('";
		    query_autori_libri+=request.getParameter("titolo");
		    query_autori_libri+="'); ";
			statement.executeQuery(query_autori_libri);
		}
		else if (request.getParameter("libronotretcorr") != null) {
		    String query_autori_libri;
		    query_autori_libri="INSERT INTO libro(Titolo) VALUES ('";
		    query_autori_libri+=request.getParameter("titolo");
		    query_autori_libri+="'); ";
			statement.executeUpdate(query_autori_libri);
		}
		else if (request.getParameter("autorilibro") != null) {
		    String query_autori_libri;
		    query_autori_libri="INSERT INTO libro(Titolo) VALUES ('";
		    query_autori_libri+=request.getParameter("titolo");
		    query_autori_libri+="') returning libroid, url; ";
		    resultSet =
			statement.executeQuery(query_autori_libri);
		    resultSet.next();
		    Integer resId = (Integer)resultSet.getObject( 1 );
		    query_autori_libri="INSERT INTO Autore_Libro(libroid, autoreid) VALUES (";
		    query_autori_libri+=resId + "," + request.getParameter("autoreid");
		    query_autori_libri+=") returning Autore_Libro_ID; ";
		    resultSet =
			statement.executeQuery(query_autori_libri);
		    // process query results
		    StringBuffer results = new StringBuffer();
		    ResultSetMetaData metaData = resultSet.getMetaData();
		    results.append("<tr>");
		    for ( int i = 1; i <= metaData.getColumnCount(); i++ ) {
			results.append( "<td><b>" + metaData.getColumnName( i )
					+ "</b></td>" );
		    }
		    results.append( "</tr>" );
		    while ( resultSet.next() ) {
			results.append("<tr>");
			for ( int i = 1; i <= metaData.getColumnCount(); i++ ) {
			    results.append("<td>"+ resultSet.getObject( i )
					   + "</td>" );
			}
			results.append( "</tr>" );
		    }
		    out.println(results.toString());
		}
	    } //fine del try
	    // detect problems interacting with the database
	    catch ( SQLException e ) {
	    	out.println("<p><b>SQL Problem: "+e.getMessage() + "</b></p>");
	    	out.println("<p><b>SQL State: "+e.getSQLState() + "</b></p>");
	    	out.println("<p><b>Error: "+e.getErrorCode() + "</b></p>");
	    	// System.exit( 1 );
	    }
	    // detect problems loading database driver
	    catch ( ClassNotFoundException e ) {
	    	out.println("<p><b>Non trovo il driver"+ e.getMessage() + "</b></p>");
	    }
	    finally {
	    	try
	    	    //eseguita sempre a meno che non venga chiamato exit()
	    	    {
	    		if (connection!=null) connection.close();
	    	    }
	    	catch (SQLException e) {
	    	    out.println("<p><b>Unable to close connection because of: " + e.getMessage() + "</b></p>");
	    	}
	    }
	    out.println("</table></body></html>");
    }
}
